﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
namespace BMM
{
    //
    // The framework being used was created by Team Wilson and is allowed to be used in any mod as long as The Power Pack Framework is a required mod (otherwise may be errors).
    // Link to PPF: https://steamcommunity.com/sharedfiles/filedetails/?id=2506978276
    // Framework coded by 🥧 Camdog74 🥧 - PS. He smells.


    //This is where you store all of your assets like your sprites, textures and sounds. (power icons too)
    public class ResourceStorage : MonoBehaviour
    {
        public Dictionary<string, Texture2D> Textures = new Dictionary<string, Texture2D>();
        public Dictionary<string, Sprite> Sprites = new Dictionary<string, Sprite>();
        public Dictionary<string, AudioClip> Sounds = new Dictionary<string, AudioClip>();

        public static Sprite HealerPowerIcon = ModAPI.LoadSprite("Art/Icons/Healer.png");
        public static Sprite HeadExploderPowerIcon = ModAPI.LoadSprite("Art/Icons/Head Exploder.png");
        public static Sprite LaserEyesPowerIcon = ModAPI.LoadSprite("Art/Icons/Laser.png");
        public static Sprite FlyingFistIcon = ModAPI.LoadSprite("Art/Icons/Flying Fist.png");
        public static Sprite flyingquestionIcon = ModAPI.LoadSprite("Art/Icons/mysteriopower.png");
        public static Sprite GrenadierIcon = ModAPI.LoadSprite("Art/Icons/Grenadier.png");
        public static Sprite ThickSkinIcon = ModAPI.LoadSprite("Art/Icons/Thick Skin.png");
        public static Sprite BigFist = ModAPI.LoadSprite("Art/Particles/Fist - Copy.png");
        public static Sprite BigQuestion = ModAPI.LoadSprite("Art/Particles/Question - Copy.png");
        public static Sprite CapeBase = ModAPI.LoadSprite("Art/Cape/cape01.png");
        public static Sprite CapeTexture = ModAPI.LoadSprite("Art/Cape/cape02.png");
        public static Sprite CapeBase2 = ModAPI.LoadSprite("Art/Cape/cape03.png");
        public static Sprite CapeTexture2 = ModAPI.LoadSprite("Art/Cape/cape04.png");

        public static Texture2D HealerParticles = ModAPI.LoadTexture("Art/Particles/Health.png");
        public static Texture2D FistParticles = ModAPI.LoadTexture("Art/Particles/Fist.png");
        public static Texture2D MysterioParticles = ModAPI.LoadTexture("Art/Particles/question.png");

        public static AudioClip LaserShoot = ModAPI.LoadSound("Sounds/LazerBlast.wav");
        public static AudioClip FistShoot = ModAPI.LoadSound("Sounds/Fist Shot.wav");
        public static AudioClip FistAmb = ModAPI.LoadSound("Sounds/Fist_Amb.wav");



    }

    public class BMM
    {
        public static string ModTag = "<color=red>[Marvel Multiverse] <color=white>";
        public static void Main() 
        {	
           CategoryBuilder.Create("Blocksify's Marvel Multiverse", "Marvel Multiverse", ModAPI.LoadSprite("catagory.png"));

            GameObject ResourceManager = new GameObject();
            ResourceManager.AddComponent<ResourceStorage>();

            #region Mod

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), 
                    NameOverride = "<color=yellow>[SYRINGE]<color=white> Electric Hands syringe " + ModTag,
                    DescriptionOverride = "Interact with hands to have a eletrical zap", 
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"),
                    ThumbnailOverride = ModAPI.LoadSprite("art/skins/Electro/syringepfp.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.AddComponent<electricHandsSyringe>();
                        Instance.GetComponent<SpriteRenderer>().color = Color.cyan;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), 
                    NameOverride = "<color=yellow>[SYRINGE]<color=white> Mysterious Bolts syringe " + ModTag,
                    DescriptionOverride = "works well with Jeopardy Thinking Music", 
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"),
                    ThumbnailOverride = ModAPI.LoadSprite("art/skins/Mysterio/syringepfp.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.AddComponent<MysterioSyringe>();
                        Instance.GetComponent<SpriteRenderer>().color = Color.green;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), 
                    NameOverride = "<color=yellow>[SYRINGE]<color=white> Laser Eyes syringe " + ModTag,
                    DescriptionOverride = "Interact with head to shoot lasers out of head", 
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"),
                    ThumbnailOverride = ModAPI.LoadSprite("art/skins/Cyclops/syringepfp.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.AddComponent<LaserEyeSyringe>();
                        Instance.GetComponent<SpriteRenderer>().color = Color.red;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), 
                    NameOverride = "<color=yellow>[SYRINGE]<color=white> Repulsor syringe " + ModTag,
                    DescriptionOverride = "Interact with head to shoot lasers out of hands", 
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"),
                    ThumbnailOverride = ModAPI.LoadSprite("art/skins/Cyclops/syringepfp.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.AddComponent<LaserSyringe>();
                        Instance.GetComponent<SpriteRenderer>().color = Color.red;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = "<color=blue>{HERO}<color=white> Deadpool " + ModTag,
                    DescriptionOverride = "Please don't make the super suit green... or animated! \n - Has Mutliple Textures", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/deadpool/deadpoolpfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/Deadpool/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Deadpool/CustomSkins/xmen.png"), "Xmen Suit", "Xmen Suit");                       
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Deadpool/CustomSkins/Skin_Layer_X.png"), "X-Force Suit", "X-Force Suit");        
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Deadpool/CustomSkins/unmasked.png"), "Unmasked Suit", "unmasked!");          

                    }
                }
            );
                ModAPI.Register(
                    new Modification()
                    {
                    OriginalItem = ModAPI.FindSpawnable("Pistol"), // Searches the ingame catalog and returns with the inputted string if possible.
                    NameOverride = "<color=purple>{WEAPON}<color=white> Deadpool's Pistol " + ModTag,
                    DescriptionOverride = "PEW PEW",
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("art/skins/deadpool/gunpfp.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                   {
                       Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/skins/deadpool/ica.png", 2f);
					   Instance.FixColliders();
					   Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.3f, 0.05f);
					   var firearm = Instance.GetComponent<FirearmBehaviour>();
					   firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/27.mp3")
                        };
						Instance.GetComponent<PhysicalBehaviour>().HoldingPositions = new[]
						{
                            new Vector3(-0.2f, -0.05f)
                        };
                    }
                }
            );
                ModAPI.Register(
                    new Modification()
                    {
                    OriginalItem = ModAPI.FindSpawnable("Pistol"), // Searches the ingame catalog and returns with the inputted string if possible.
                    NameOverride = "<color=purple>{WEAPON}<color=white> Punishers's Silenced Pistol " + ModTag,
                    DescriptionOverride = "A weapoon to punish",
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("art/skins/punisher/gun2pfp.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                   {
                       Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/skins/punisher/gun2.png", 2f);
					   Instance.FixColliders();
					   Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.3f, 0.05f);
					   var firearm = Instance.GetComponent<FirearmBehaviour>();
					   firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/AR.mp3")
                        };
						Instance.GetComponent<PhysicalBehaviour>().HoldingPositions = new[]
						{
                            new Vector3(-0.2f, -0.05f)
                        };
                    }
                }
            );
                ModAPI.Register(
                    new Modification()
                    {
                    OriginalItem = ModAPI.FindSpawnable("Assault Rifle"), // Searches the ingame catalog and returns with the inputted string if possible.
                    NameOverride = "<color=purple>{WEAPON}<color=white> Punisher's Assault Rifle " + ModTag , // Name.
                    DescriptionOverride = "A weapon to punish",// Description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("art/skins/punisher/gunpfp.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                   {
                       Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/skins/punisher/gun.png", 2f);
					   Instance.FixColliders();
					   Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.3f, 0.05f);
					   var firearm = Instance.GetComponent<FirearmBehaviour>();
						Instance.GetComponent<PhysicalBehaviour>().HoldingPositions = new[]
						{
                            new Vector3(-0.2f, -0.05f)
                        };
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = "<color=blue>{HERO}<color=white> Tony Stark " + ModTag,
                    DescriptionOverride = "I am Ironman \n - Has Mutliple Textures", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/ironman/starkpfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {

                        //get person
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");

                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/ironman/Skin Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2); 

                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = "<color=red>{VILLIAN}<color=white> Punisher " + ModTag,
                    DescriptionOverride = "One batch, two batch, penny and dime", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/Punisher/pfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {

                        //get person
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");

                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/Punisher/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2); 

                    }
                }
            );


            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                     NameOverride = "<color=blue>{HERO}<color=white>  James Rhodes " + ModTag,
                    DescriptionOverride = "If You Want This Suit, You’re Going To Have To Pry My Cold Dead Body Out Of It \n - Has Mutliple Textures", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/Rhodey/pfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/Rhodey/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);       

                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                     NameOverride = "<color=blue>{HERO}<color=white> Thor " + ModTag,
                    DescriptionOverride = "If You Want This Suit, You’re Going To Have To Pry My Cold Dead Body Out Of It \n - Has Mutliple Textures", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/thor/pfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/thor/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);
						
                        int X;

                        PowerPackFrameworkFunctions.CreateCape(person, ResourceStorage.CapeTexture, 0.15f, ResourceStorage.CapeBase);
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/thor/CustomSkins/skin 1.png"),"Beared Thor", "Beared Thor");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/thor/CustomSkins/skin 2.png"),"Thor Ragnarok Outfit", "Thor Ragnarok Outfit");
                        //Gets all the characters limbs               
                        foreach (LimbBehaviour Limb in person.Limbs)
                        {
                                Limb.BreakingThreshold *= 10f;
                                Limb.ImmuneToDamage = true;
                                Limb.ImpactPainMultiplier = 0f;
                                Limb.ShotDamageMultiplier = 0f;
                                Limb.Vitality *= 100f;
                                Limb.Health *= 100f;
                                Limb.FakeUprightForce *= 1.65f;
                                Limb.InitialHealth *= 100f;
                                Limb.IsLethalToBreak = false;
                                Limb.PhysicalBehaviour.BurningProgressionMultiplier = 0f;
                                Limb.CirculationBehaviour.BloodLossRateMultiplier = 0f;
                                Limb.CirculationBehaviour.ImmuneToDamage = true;
                        }
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                     NameOverride = "<color=red>{VILLIAN}<color=white> Thanos " + ModTag,
                    DescriptionOverride = "Perfectly Balanced, as all things should be. \n - Has Mutliple Textures", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/thanos/pfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/thanos/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);
						
                        int X;
                        //Gets all the characters limbs               
                        arm1.gameObject.AddComponent<Hand>();

                        GameObject hands = new GameObject();
                        hands.transform.parent = arm1;
                        hands.transform.localPosition = new Vector4(0f, 0f);
                        hands.transform.localScale = new Vector4(1f, 1f);

                        var handsprite = hands.AddComponent<SpriteRenderer>();

                        handsprite.sprite = ModAPI.LoadSprite("art/skins/thanos/gauntlet.png");
                        handsprite.sortingLayerName = "Top";

                        foreach (var body in person.Limbs)
                        {
                                body.BreakingThreshold *= 10f;
                                body.ImmuneToDamage = true;
                                body.ImpactPainMultiplier = 0f;
                                body.ShotDamageMultiplier = 0f;
                                body.Vitality *= 100f;
                                body.Health *= 100f;
                                body.FakeUprightForce *= 1.65f;
                                body.InitialHealth *= 100f;
                                body.IsLethalToBreak = false;
                                body.PhysicalBehaviour.BurningProgressionMultiplier = 0f;
                                body.CirculationBehaviour.BloodLossRateMultiplier = 0f;
                                body.CirculationBehaviour.ImmuneToDamage = true;
                            

                            if (body.GetComponent<GripBehaviour>() && body.gameObject.name == "LowerArmFront")
                            {
                                body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                                {
                                    GameObject HandOBJ2 = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Detached Laser Cannon").Prefab.GetComponent<BlasterBehaviour>().Bolt);
                                    HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.startColor = new Color(217, 0, 255);
                                    HandOBJ2.GetComponent<BlasterboltBehaviour>().Trail.endColor = new Color(217, 0, 255);

                                    ModAPI.CreateParticleEffect("Vapor", new Vector2(arm1.transform.position.x, arm1.transform.position.y + 0.1f));
                                    HandOBJ2.transform.position = body.gameObject.transform.position;
                                    HandOBJ2.transform.eulerAngles = body.gameObject.transform.eulerAngles;
                                    HandOBJ2.transform.eulerAngles += new Vector3(0, 0, 270);

                                    AudioSource audio = body.gameObject.AddComponent<AudioSource>();
                                    audio.spatialBlend = 1;
                                };
                            }
                        }
                        Instance.transform.localScale = new Vector2(((Instance.transform.localScale.x <= 0)? -1.5f : 1.5f), 1.5f);
                        }
                    }
                ); 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                     NameOverride = "<color=blue>{HERO}<color=white> Captain America - Steve Rogers " + ModTag,
                    DescriptionOverride = "'MERICA! \n - Has Mutliple Textures", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/captainamerica/pfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/captainamerica/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);
						
                        int X;

                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/captainamerica/CustomSkins/skin 1.png"),"Infinity War Suit", "Infinity War Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/captainamerica/CustomSkins/skin 2.png"),"Unmasked", "Unmasked");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/captainamerica/CustomSkins/skin 3.png"),"Hydra Suit", "Hydra Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/captainamerica/CustomSkins/skin 4.png"),"Stealth Suit", "Stealth Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/captainamerica/CustomSkins/skin 5.png"),"The Avengers Game Artic Commander Suit", "The Avengers Game Artic Commander Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/captainamerica/CustomSkins/skin 6.png"),"The Avengers Game Super Solider Suit", "The Avengers Game Super Solider Suit");
                        //Gets all the characters limbs               
                        foreach (LimbBehaviour Limb in person.Limbs)
                        {
                                Limb.BreakingThreshold *= 10f;
                                Limb.ImpactPainMultiplier = 0f;
                                Limb.ShotDamageMultiplier = 0f;
                                Limb.Vitality *= 100f;
                                Limb.Health *= 100f;
                                Limb.FakeUprightForce *= 1.65f;
                                Limb.InitialHealth *= 100f;
                                Limb.IsLethalToBreak = false;
                        }
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                     NameOverride = "<color=blue>{HERO}<color=white>  Captain America - John Walker " + ModTag,
                    DescriptionOverride = "'MERICA! \n - Has Mutliple Textures", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/johnwalker/pfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/johnwalker/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/johnwalker/CustomSkins/usagent.png"),"Us Agent Suit", "Us Agent Suit");
						
                        int X;
                        //Gets all the characters limbs               
                        foreach (LimbBehaviour Limb in person.Limbs)
                        {
                                Limb.BreakingThreshold *= 10f;
                                Limb.ImpactPainMultiplier = 0f;
                                Limb.ShotDamageMultiplier = 0f;
                                Limb.Vitality *= 100f;
                                Limb.Health *= 100f;
                                Limb.FakeUprightForce *= 1.65f;
                                Limb.InitialHealth *= 100f;
                                Limb.IsLethalToBreak = false;
                        }
                    }
                }
            );
             ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                     NameOverride = "<color=purple>{WEAPON}<color=white> Captain America's Shield " + ModTag,
                    DescriptionOverride = "Captain America's Lovely Shield \n - Use this to block bullets and etc.",
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"),
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/captainamerica/shieldpfp.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/skins/CaptainAmerica/shield.png");
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.transform.localScale = Instance.transform.localScale * -1f;
                        Instance.transform.localScale += new Vector3(0,0.2f,0);
                        Instance.FixColliders();
                    }
                }
            );
             ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                     NameOverride = "<color=purple>{WEAPON}<color=white> Wakandan Shield " + ModTag,
                    DescriptionOverride = "Captain America's Lovely Shield \n - Use this to block bullets and etc.",
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"),
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/captainamerica/shield2pfp.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/skins/CaptainAmerica/shield2.png");
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.transform.localScale = Instance.transform.localScale * 0.5f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties.Softness = -450;
                        Instance.GetComponent<PhysicalBehaviour>().Properties.Brittleness = 99;
                        Instance.transform.localScale += new Vector3(0,0.2f,0);
                        Instance.FixColliders();
                    }
                }
            );
             ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                     NameOverride = "<color=purple>{WEAPON}<color=white> John Walker's Shield " + ModTag,
                    DescriptionOverride = "Captain America's Lovely Shield \n - Use this to block bullets and etc.",
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"),
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/johnwalker/shieldpfp.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/skins/johnwalker/shield.png");
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.transform.localScale = Instance.transform.localScale * -1f;
                        Instance.transform.localScale += new Vector3(0,0.2f,0);
                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                     NameOverride = "<color=blue>{HERO}<color=white> Spider-Man - Peter Parker" + ModTag,
                    DescriptionOverride = "Remember, with great power comes great responsibility.\n Has Multiple Textures", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/Spiderman/pfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");

									hand1.gameObject.AddComponent<Web>();
									hand2.gameObject.AddComponent<Web>();

                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/Spiderman/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);

                        int X;

                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/unmasked.png"),"Unmasked", "Unmasked");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/citizen.png"),"citizen", "citizen");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/homemadesuit1.png"),"homemade suit Mark 1", "homemade suit Mark 1");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/homemadeSuit2.png"),"homemade Suit Mark 2", "homemade Suit Mark 2");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/Hybrid.png"),"Hybrid Suit", "Hybrid Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/Ps4.png"),"Advanced Suit", "Advanced Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/Raimi3.png"),"Raimi Trilogy", "Raimi Trilogy");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/RaimiBlack.png"),"Raimi Trilogy Venom", "Raimi Trilogy Venom");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/RaimiBlackunmasked.png"),"Rami Trilogy Venom unmasked", "Rami Trilogy Venom unmasked");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/StarkSuit.png"),"Stark Suit", "Stark Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/Stealth.png"),"Stealth Suit", "Stealth Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/venom.png"),"venom Suit", "venom Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/AntiOck.png"),"Anti Ock Suit", "Anti Ock Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/Arachknight.png"),"Arach knight Suit", "Arach knight Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/comic.png"),"Earth 616 Comic Suit", "Earth 616 Comic Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/BombasticBagman.png"),"Bombastic Bagman Suit", "Bombastic Bagman Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/FutureFoundation.png"),"Future Foundation Suit", "Future Foundation Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/FutureFoundationStealth.png"),"Future Foundation Stealth Suit", "Future Foundation Stealth Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/housem.png"),"House of M Suit", "House of M Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/Mcusymbiote.png"),"Mcu symbiote unmasked Suit", "Mcu symbiote Unmasked Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/negative.png"),"Negative Zone Suit", "Negative Zone Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/spiderarmour.png"),"Spider Armour Mk1 Suit", "Spider Armour Mk1 Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/spiderarmour2.png"),"Spider Armour Mk2 Suit", "Spider Armour Mk2 Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/SymbioteMCU.png"),"Symbiote MCU Suit", "Symbiote MCU Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Spiderman/CustomSkins/venomps4.png"),"Symbiote PS4 Suit", "Symbiote PS4 Suit");
                        //Gets all the characters limbs
                        foreach (var body in person.Limbs)
                        {
                            //Sets up power on specific bodypart. supported bodyparts are (Head,LowerArm,UpperBody)
                        //    if (body.gameObject.name.Contains("Head"))
                         //       HealerExamplePower.SetUpPower(body, person, Instance);
                        }       

                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                     NameOverride = "<color=blue>{HERO}<color=white> Spiderman - Miles Morales " + ModTag,
                    DescriptionOverride = "I Promise To Do Everything In My Power To Protect This City. \n - Has Multiple Textures", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/miles/pfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");

									hand1.gameObject.AddComponent<Web>();
									hand2.gameObject.AddComponent<Web>();

                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/miles/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);

                        int X;

                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/miles/CustomSkins/PurpleReign.png"),"Purple Reign Suit", "Purple Reign Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/miles/CustomSkins/track.png"),"T.R.A.C.K Suit", "T.R.A.C.K Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/miles/CustomSkins/UptownPride.png"),"Uptown Pride Suit", "Uptown Pride Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/miles/CustomSkins/GreatResponsibility.png"),"Great Responsibility Suit", "Great Responsibility Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/miles/CustomSkins/homeade.png"),"homemade Suit", "homemade Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/miles/CustomSkins/Insomniac.png"),"Insomniac Ps4 Suit", "Insomniac Ps4 Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/miles/CustomSkins/jacket.png"),"Miles with a jacket", "Miles with a jacket");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/miles/CustomSkins/ProgrammableMatter.png"),"Programmable Matter Suit", "Programmable Matter Suit");

                        //Gets all the characters limbs
                        foreach (var body in person.Limbs)
                        {
                            //Sets up power on specific bodypart. supported bodyparts are (Head,LowerArm,UpperBody)
                        //    if (body.gameObject.name.Contains("Head"))
                         //       HealerExamplePower.SetUpPower(body, person, Instance);
                        }       

                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                     NameOverride = "<color=blue>{HERO}<color=white> Spiderman - Ben Rilley " + ModTag,
                    DescriptionOverride = "I am SPIDER-MAN! I'm also.. your clone. \n - Has Multiple Textures", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/BenReilly/pfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");

									hand1.gameObject.AddComponent<Web>();
									hand2.gameObject.AddComponent<Web>();

                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/BenReilly/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);

                        int X;

                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/BenReilly/customskins/SensationalSpiderMan.png"),"Sensational Spider-Man Suit", "Sensational Spider-Man Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/BenReilly/customskins/SensationalSpiderManNoLogo.png"),"Sensational Spider-Man No Logo Suit","Sensational Spider-Man No Logo Suit");

                        //Gets all the characters limbs
                        foreach (var body in person.Limbs)
                        {
                            //Sets up power on specific bodypart. supported bodyparts are (Head,LowerArm,UpperBody)
                        //    if (body.gameObject.name.Contains("Head"))
                         //       HealerExamplePower.SetUpPower(body, person, Instance);
                        }       

                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                     NameOverride = "<color=blue>{HERO}<color=white> Cyclops " + ModTag,
                    DescriptionOverride = "Well, What Would You Prefer, Yellow Spandex? \n - Has Multiple Textures", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/Cyclops/pfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");

                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/Cyclops/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);

                        int X;

                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/cyclops/CustomSkins/jacket.png"),"jacket Suit", "jacket Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/cyclops/CustomSkins/Apocalypse.png"),"Apocalypse Suit", "Apocalypse Suit");

                        //Gets all the characters limbs
                        foreach (var body in person.Limbs)
                        {
                            //Sets up power on specific bodypart. supported bodyparts are (Head,LowerArm,UpperBody)
                            if (body.gameObject.name.Contains("Head"))
                            LaserEyesPowerExample.SetUpPower(body, person, Instance, Color.red);
                        }       

                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                     NameOverride = "<color=blue>{HERO}<color=white> Ghost Spider - Gwen Stacey " + ModTag,
                    DescriptionOverride = "What a pig. - Gwen Stacey \n - Has Multiple Textures", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/GwenStacy/pfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");

									hand1.gameObject.AddComponent<Web>();
									hand2.gameObject.AddComponent<Web>();

                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/GwenStacy/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);

                        int X;

                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/GwenStacy/CustomSkins/citizen.png"),"Citizen Suit", "Citizen Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/GwenStacy/CustomSkins/ITSVGwen.png"),"ITSV Gwen Suit", "ITSV Gwen");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/GwenStacy/CustomSkins/spiderverse.png"),"spiderverse Suit", "spiderverse Suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/GwenStacy/CustomSkins/unmasked.png"),"unmasked Suit", "unmasked Gwen");

                        //Gets all the characters limbs
                        foreach (var body in person.Limbs)
                        {
                            //Sets up power on specific bodypart. supported bodyparts are (Head,LowerArm,UpperBody)
                        //    if (body.gameObject.name.Contains("Head"))
                         //       HealerExamplePower.SetUpPower(body, person, Instance);
                        }       

                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                     NameOverride = "<color=red>{VILLIAN}<color=white> Carnage " + ModTag,
                    DescriptionOverride = "I am the ultimate insanity! I am CARNAGE!", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/Carnage/pfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");

									hand1.gameObject.AddComponent<Web>();
									hand2.gameObject.AddComponent<Web>();

                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/Carnage/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);

                        int X;

                        foreach (var body in person.Limbs)
                        {
                            //Sets up power on specific bodypart. supported bodyparts are (Head,LowerArm,UpperBody)
                        //    if (body.gameObject.name.Contains("Head"))
                         //       HealerExamplePower.SetUpPower(body, person, Instance);
                        }       

                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                     NameOverride = "<color=blue>{HERO}<color=white> Black Panther " + ModTag,
                    DescriptionOverride = "We serve Wakanda. And let us not forget, we also serve each other. Together we will always rise\n-Spawns with claws click f on the hand while close to equipt\n-Has Multiple Textures", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/blackpanther/pfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");

                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/blackpanther/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);

                        int X;

                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/blackpanther/CustomSkins/Civilwar.png"),"Civil War Suit", "Civil War Suit");

                        foreach (var body in person.Limbs)
                        {
                            Sprite Clawsprite = ModAPI.LoadSprite("art/skins/blackpanther/claw.png");
                            string OriginalItem = "Knife";
                            bool RedoCollisions = false;
                            bool SmoothScale = false; ;

                        if (body.GetComponent<GripBehaviour>())
                        {
                            GameObject claw = GameObject.Instantiate(ModAPI.FindSpawnable(OriginalItem).Prefab);
                            if (Instance.transform.localScale.x < 0)
                                claw.transform.localScale = new Vector3(-claw.transform.localScale.x, claw.transform.localScale.y, claw.transform.localScale.z);
                            claw.GetComponent<SpriteRenderer>().sprite = Clawsprite;
                            if (RedoCollisions)
                            {
                                claw.FixColliders();
                            }
                            claw.transform.position = body.transform.position;

                            claw.transform.eulerAngles = new Vector3(claw.transform.eulerAngles.x, claw.transform.eulerAngles.y, claw.transform.eulerAngles.z + 180);
                            foreach (var limbs in person.Limbs)
                                Physics2D.IgnoreCollision(limbs.GetComponent<Collider2D>(), claw.GetComponent<Collider2D>());
                            foreach (var limbs in person.Limbs)
                            {
                            };
                        }
                        }       
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                     NameOverride = "<color=red>{VILLIAN}<color=white> Venom " + ModTag,
                    DescriptionOverride = "We are.. VENOM \n - Has Mutliple Textures", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/Venom/pfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");

									hand1.gameObject.AddComponent<blackweb>();
									hand2.gameObject.AddComponent<blackweb>();

                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/Venom/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);

                        int X;

                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Venom/CustomSkins/antivenom.png"),"anti-venom", "anti-venom");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Venom/CustomSkins/comicbook.png"),"comicbook suit", "comicbook suit");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Venom/CustomSkins/venomsuit.png"),"Venom in a suit", "Venom in a suit");
                        //Gets all the characters limbs
                        foreach (var body in person.Limbs)
                        {
                            //Sets up power on specific bodypart. supported bodyparts are (Head,LowerArm,UpperBody)
                           // if (body.gameObject.name.Contains("Head"))
                             //   HealerExamplePower.SetUpPower(body, person, Instance);
                        }       
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                    NameOverride = "<color=blue>{HERO}<color=white> Moon Knight " + ModTag,
                    DescriptionOverride = "I became Moon Knight to battle evil wherever I could find it. And I never had to look farther than the darkness inside my own heart. I am Moon Knight.\n - Has Mutliple Textures", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/moonknight/pfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");

                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/moonknight/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);

                        int X;

                        PowerPackFrameworkFunctions.CreateCape(person, ResourceStorage.CapeTexture2, 0.15f, ResourceStorage.CapeBase2);
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/moonknight/CustomSkins/MrKnight.png"),"Mr Knight", "Mr Knight");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/moonknight/CustomSkins/StevenGrant.png"),"Steven Grant", "Steven Grant");
                        //Gets all the characters limbs
                        foreach (var body in person.Limbs)
                        {
                            //Sets up power on specific bodypart. supported bodyparts are (Head,LowerArm,UpperBody)
                            //if (body.gameObject.name.Contains("Head"))
                             //HealerExamplePower.SetUpPower(body, person, Instance);
                        }       
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                         NameOverride = "<color=blue>{HERO}<color=white> Bruce Banner " + ModTag,
                    DescriptionOverride = "IT WOULD BE EXTREMELY PAINFUL...FOR YOU. - Bane", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/Bruce/pfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/bruce/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);    
                    }
                }
            );
            			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "<color=blue>{HERO}<color=white> Iron-Man " + ModTag,
					DescriptionOverride = "And I... am... Ironman. *snaps* \n - Has Mutliple Textures", //new item description
					CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/ironman/pfp.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
									var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");

									upper.gameObject.AddComponent<Uni>();

                                    person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/ironman/Suit Layer.png"), ModAPI.LoadTexture("Art/Skins/ironman/suit damage.png"), null, 2);
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark1.png"), "Mark 1 Suit", "Mark 1"); 
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark2.png"), "Mark 2 Suit", "Mark 2"); 
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark3.png"), "Mark 3 Suit", "Mark 3"); 
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark4.png"), "Mark 4 Suit", "Mark 4");    
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark5.png"), "Mark 5 Suit", "Mark 5");    
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark6.png"), "Mark 6 Suit", "Mark 6");    
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark7.png"), "Mark 7 Suit", "Mark 7");    
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark8.png"), "Mark 8 Suit", "Mark 8");
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark9.png"), "Mark 9 Suit", "Mark 9");    
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark10.png"), "Mark 10 Suit", "Mark 10");     
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark13.png"), "Mark 13 Suit", "Mark 13");    
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark14.png"), "Mark 14 Suit", "Mark 14");     
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark17.png"), "Mark 17 Suit", "Mark 17");     
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark18.png"), "Mark 10 Suit", "Mark 18");  
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark20.png"), "Mark 10 Suit", "Mark 20"); 
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark21.png"), "Mark 10 Suit", "Mark 21"); 
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark30.png"), "Mark 10 Suit", "Mark 30"); 
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark32.png"), "Mark 10 Suit", "Mark 32"); 
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark33.png"), "Mark 10 Suit", "Mark 33");     
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark40.png"), "Mark 10 Suit", "Mark 40");     
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark41.png"), "Mark 10 Suit", "Mark 41");     
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark42.png"), "Mark 10 Suit", "Mark 42");     
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark43.png"), "Mark 10 Suit", "Mark 43");     
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark46.png"), "Mark 10 Suit", "Mark 46");     
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark47.png"), "Mark 10 Suit", "Mark 47");     
                                    PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Ironman/CustomSkins/mark49.png"), "Mark 10 Suit", "Mark 49");     	
									
									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									AudioClip Gauntlet = ModAPI.LoadSound("Gauntlet.mp3");
									 
									

    
                                    int X;

										foreach (var body in person.Limbs)
										if (body.GetComponent<GripBehaviour>())

											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.white;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 0.2f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 1000f;
												
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
									
										};
					}
					}				
					}
                   );
				
				ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "<color=blue>{HERO}<color=white>  Iron Patriot " + ModTag,
					DescriptionOverride = "WAR MACHINE ROX with an 'X", //new item description
					CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/warmachine/patriotpfp.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("Art/skins/warmachine/mark3Eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 0f, 0f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Foreground";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite1 = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite1.sprite = ModAPI.LoadSprite("Art/skins/warmachine/mark3ARC.png");
            						upperbigtimeprite1.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite1.color = new Color(1f, 0f, 0f, 0.25f);
									upperbigtimeprite1.sortingLayerName = "Foreground";	
															
									var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
									person.SetBodyTextures(ModAPI.LoadTexture("Art/skins/warmachine/Patriot.png"), ModAPI.LoadTexture("Art/skins/warmachine/Patriot.png"), null, 2);
									
									
									person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("art/skins/WarMachine/PatriotHead.png", 2);
									person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotHead.png"));
									person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotHead.png"));
									
									
									
									person.Limbs[1].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("art/skins/WarMachine/PatriotArmor.png", 2);
									person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotArmor.png"));
									person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotArmor.png"));
									
									
									
									person.Limbs[2].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("art/skins/WarMachine/PatriotMiddle.png", 2);
									person.Limbs[2].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotMiddle.png"));
									person.Limbs[2].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotMiddle.png"));
									
									
									
									person.Limbs[3].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("art/skins/WarMachine/PatriotLower.png", 2);
									person.Limbs[3].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotLower.png"));
									person.Limbs[3].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotLower.png"));
									
									
									
									person.Limbs[4].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("art/skins/WarMachine/PatriotUpperLeg.png", 2);
									person.Limbs[4].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotUpperLeg.png"));
									person.Limbs[4].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotUpperLeg.png"));
								
									
									
									person.Limbs[5].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("art/skins/WarMachine/PatriotLowerLeg.png", 2);
									person.Limbs[5].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotLowerLeg.png"));
									person.Limbs[5].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotLowerLeg.png"));
									
									
									
									person.Limbs[6].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("art/skins/WarMachine/PatriotUpperFoot.png", 2);
									person.Limbs[6].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotUpperFoot.png"));
									person.Limbs[6].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotUpperFoot.png"));
									
									
									
									person.Limbs[7].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("art/skins/WarMachine/PatriotUpperLeg.png", 2);
									person.Limbs[7].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotUpperLeg.png"));
									person.Limbs[7].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotUpperLeg.png"));
									
									
									
									person.Limbs[8].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("art/skins/WarMachine/PatriotLowerLeg.png", 2);
									person.Limbs[8].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotLowerLeg.png"));
									person.Limbs[8].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotLowerLeg.png"));
									
									
									
									person.Limbs[9].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("art/skins/WarMachine/PatriotUpperFoot.png", 2);
									person.Limbs[9].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotUpperFoot.png"));
									person.Limbs[9].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotUpperFoot.png"));
									
									
									
									person.Limbs[10].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("art/skins/WarMachine/PatriotUpperArm.png", 2);
									person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotUpperArm.png"));
									person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotUpperArm.png"));
									
									
									
									person.Limbs[11].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("art/skins/WarMachine/PatriotArm.png", 2);
									person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotArm.png"));
									person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotArm.png"));
									
									
									
									person.Limbs[12].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("art/skins/WarMachine/PatriotUpperArm.png", 2);
									person.Limbs[12].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotUpperArm.png"));
									person.Limbs[12].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotUpperArm.png"));
									
									
									
									person.Limbs[13].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("art/skins/WarMachine/PatriotArm.png", 2);
									person.Limbs[13].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotArm.png"));
									person.Limbs[13].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("art/skins/WarMachine/PatriotArm.png"));

                        arm1.gameObject.AddComponent<BarretBehaviour>();
                        arm2.gameObject.AddComponent<BarretBehaviour>();
                        GameObject alsoEye = new GameObject();
                        alsoEye.transform.parent = arm1;
                        alsoEye.transform.localPosition = new Vector3(0f, 0f);
                        alsoEye.transform.localScale = new Vector3(1f, 1f);

                        var eyeSprite = alsoEye.AddComponent<SpriteRenderer>();

                        eyeSprite.sprite = ModAPI.LoadSprite("art/skins/WarMachine/PatriotArm.png");
                        eyeSprite.material = ModAPI.FindMaterial("Sprites-Default");
                        eyeSprite.sortingLayerName = "Top";

                        GameObject secondarm = new GameObject();
                        secondarm.transform.parent = arm2;
                        secondarm.transform.localPosition = new Vector3(0f, 0f);
                        secondarm.transform.localScale = new Vector3(1f, 1f);

                        var armSprite = secondarm.AddComponent<SpriteRenderer>();

                        armSprite.sprite = ModAPI.LoadSprite("art/skins/WarMachine/PatriotArm.png");
                        armSprite.material = ModAPI.FindMaterial("Sprites-Default");
                        armSprite.sortingLayerName = "Bottom";
                   }}
                }
            );
            ModAPI.Register(
            new Modification()
            {
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "<color=blue>{HERO}<color=white>  War Machine " + ModTag,
					DescriptionOverride = "This Lone Gunslinger Act Is Unnecessary, you don’t Have To Do This Alone", //new item description
					CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Art/skins/warmachine/warmachinepfp.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("Art/skins/warmachine/mark3Eyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 0f, 0f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Foreground";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite1 = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite1.sprite = ModAPI.LoadSprite("Art/skins/warmachine/mark3ARC.png");
            						upperbigtimeprite1.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite1.color = new Color(1f, 0f, 0f, 0.25f);
									upperbigtimeprite1.sortingLayerName = "Foreground";		
															
									var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
									person.SetBodyTextures(ModAPI.LoadTexture("Art/skins/warmachine/mark3.png"), ModAPI.LoadTexture("Art/skins/warmachine/mark3.png"), null, 2);
									
									
									person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/WarMachine/Mark3Head.png", 2);
									person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/WarMachine/mark3Head.png"));
									person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/WarMachine/mark3Head.png"));
									
									
									person.Limbs[1].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/WarMachine/mark3Upper.png", 2);
									person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/WarMachine/mark3Upper.png"));
									person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/WarMachine/mark3Upper.png"));
									
									
									person.Limbs[2].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/WarMachine/mark3Middle.png", 2);
									person.Limbs[2].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/WarMachine/mark3Middle.png"));
									person.Limbs[2].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/WarMachine/mark3Middle.png"));
									
									
									person.Limbs[3].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/WarMachine/mark3Lower.png", 2);
									person.Limbs[3].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/WarMachine/mark3Lower.png"));
									person.Limbs[3].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/WarMachine/mark3Lower.png"));
				
									
									person.Limbs[10].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/WarMachine/mark3UpperArm.png", 2);
									person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/WarMachine/mark3UpperArm.png"));
									person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/WarMachine/mark3UpperArm.png"));
									
									
									person.Limbs[11].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/WarMachine/mark3LowerArm.png", 2);
									person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/WarMachine/mark3LowerArm.png"));
									person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/WarMachine/mark3LowerArm.png"));
									
									
									person.Limbs[12].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/WarMachine/mark3UpperArm.png", 2);
									person.Limbs[12].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/WarMachine/mark3UpperArm.png"));
									person.Limbs[12].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/WarMachine/mark3UpperArm.png"));
									
									
									person.Limbs[13].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/WarMachine/mark3LowerArm.png", 2);
									person.Limbs[13].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/WarMachine/mark3LowerArm.png"));
									person.Limbs[13].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/WarMachine/mark3LowerArm.png"));

                        arm1.gameObject.AddComponent<BarretBehaviour>();
                        arm2.gameObject.AddComponent<BarretBehaviour>();
                        GameObject alsoEye = new GameObject();
                        alsoEye.transform.parent = arm1;
                        alsoEye.transform.localPosition = new Vector3(0f, 0f);
                        alsoEye.transform.localScale = new Vector3(1f, 1f);

                        var eyeSprite = alsoEye.AddComponent<SpriteRenderer>();

                        eyeSprite.sprite = ModAPI.LoadSprite("Art/skins/WarMachine/mark3LowerArm.png");
                        eyeSprite.material = ModAPI.FindMaterial("Sprites-Default");
                        eyeSprite.sortingLayerName = "Top";

                        GameObject secondarm = new GameObject();
                        secondarm.transform.parent = arm2;
                        secondarm.transform.localPosition = new Vector3(0f, 0f);
                        secondarm.transform.localScale = new Vector3(1f, 1f);

                        var armSprite = secondarm.AddComponent<SpriteRenderer>();

                        armSprite.sprite = ModAPI.LoadSprite("Art/skins/WarMachine/mark3LowerArm.png");
                        armSprite.material = ModAPI.FindMaterial("Sprites-Default");
                        armSprite.sortingLayerName = "Bottom";
                   }}
                }
            );
            ModAPI.Register(
            new Modification()
            {
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "<color=blue>{HERO}<color=white>  Mark 44 - HullkBuster " + ModTag,
					DescriptionOverride = "Right, don't mention puny Banner...", //new item description
					CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Art/skins/ironman/hulkbuster/mark44pfp.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   
									{
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

									GameObject Eyebigtime1 = new GameObject();
            						Eyebigtime1.transform.parent = head;
            						Eyebigtime1.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime1.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite1 = Eyebigtime1.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite1.sprite = ModAPI.LoadSprite("Art/skins/ironman/hulkbuster/Mark44Eyelight.png");
									eyebigtimeSprite1.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite1.color = new Color(0f, 0.65f, 1f, 0.25f);
            						eyebigtimeSprite1.sortingLayerName = "Foreground";

									GameObject upperbigtime1 = new GameObject();
            						upperbigtime1.transform.parent = upper;
            						upperbigtime1.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime1.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite1 = upperbigtime1.AddComponent<SpriteRenderer>();

            						upperbigtimeprite1.sprite = ModAPI.LoadSprite("Art/skins/ironman/hulkbuster/Mark44ARC.png");
            						upperbigtimeprite1.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite1.color = new Color(0f, 0.65f, 1f, 0.25f);
									upperbigtimeprite1.sortingLayerName = "Foreground";	

									GameObject legs41 = new GameObject();
									legs41.transform.parent = leg4;
									legs41.transform.localPosition = new Vector4(0f, 0f);
									legs41.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite41 = legs41.AddComponent<SpriteRenderer>();

									legsprite41.sprite = ModAPI.LoadSprite("Art/skins/ironman/hulkbuster/Mark44LegARC.png");
									legsprite41.sortingLayerName = "Foreground";
									legsprite41.color = new Color(0f, 0.65f, 1f, 0.25f);
									legsprite41.material = ModAPI.FindMaterial("VeryBright");		
									
									
									
									
									
									
									
									
									GameObject legs21 = new GameObject();
									legs21.transform.parent = leg2;
									legs21.transform.localPosition = new Vector4(0f, 0f);
									legs21.transform.localScale = new Vector4(0.5f, 0.5f);
									
									var legsprite21 = legs21.AddComponent<SpriteRenderer>();

									legsprite21.sprite = ModAPI.LoadSprite("Art/skins/ironman/hulkbuster/Mark44LegARC.png");
									legsprite21.sortingLayerName = "Foreground";
									legsprite21.color = new Color(0f, 0.65f, 1f, 0.25f);
									legsprite21.material = ModAPI.FindMaterial("VeryBright");	

									int X;
									var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
									person.SetBodyTextures(ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/mark44.png"), ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/mark44.png"), null, 2);

									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									
									upper.gameObject.AddComponent<Uni>();
									
									
									person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ironman/hulkbuster/Mark44Head.png", 2);
									person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44Head.png"));
									person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44Head.png"));
									
									
									person.Limbs[1].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ironman/hulkbuster/Mark44Upper.png", 2);
									person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44Upper.png"));
									person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44Upper.png"));
									
									
									person.Limbs[2].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ironman/hulkbuster/Mark44Middle.png", 2);
									person.Limbs[2].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44Middle.png"));
									person.Limbs[2].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44Middle.png"));
									
									
									person.Limbs[3].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ironman/hulkbuster/Mark44Lower.png", 2);
									person.Limbs[3].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44Lower.png"));
									person.Limbs[3].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44Lower.png"));
									
									
									person.Limbs[4].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ironman/hulkbuster/Mark44UpperLeg.png", 2);
									person.Limbs[4].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44UpperLeg.png"));
									person.Limbs[4].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44UpperLeg.png"));
									
									
									person.Limbs[5].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ironman/hulkbuster/Mark44LowerLeg.png", 2);
									person.Limbs[5].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44LowerLeg.png"));
									person.Limbs[5].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44LowerLeg.png"));
									
									
									person.Limbs[6].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ironman/hulkbuster/Mark44Foot.png", 2);
									person.Limbs[6].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44Foot.png"));
									person.Limbs[6].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44Foot.png"));
									
									
									person.Limbs[7].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ironman/hulkbuster/Mark44UpperLeg.png", 2);
									person.Limbs[7].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44UpperLeg.png"));
									person.Limbs[7].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44UpperLeg.png"));
									
									
									person.Limbs[8].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ironman/hulkbuster/Mark44LowerLeg.png", 2);
									person.Limbs[8].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44LowerLeg.png"));
									person.Limbs[8].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44LowerLeg.png"));
									
									
									person.Limbs[9].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ironman/hulkbuster/Mark44Foot.png", 2);
									person.Limbs[9].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44Foot.png"));
									person.Limbs[9].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44Foot.png"));
									
									
									person.Limbs[10].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ironman/hulkbuster/Mark44UpperArm.png", 2);
									person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44UpperArm.png"));
									person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44UpperArm.png"));
									
									
									person.Limbs[11].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ironman/hulkbuster/Mark44LowerArm.png", 2);
									person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44LowerArm.png"));
									person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44LowerArm.png"));
									
									
									person.Limbs[12].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ironman/hulkbuster/Mark44UpperArm.png", 2);
									person.Limbs[12].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44UpperArm.png"));
									person.Limbs[12].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44UpperArm.png"));
									
									
									person.Limbs[13].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ironman/hulkbuster/Mark44LowerArm.png", 2);
									person.Limbs[13].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44LowerArm.png"));
									person.Limbs[13].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ironman/hulkbuster/Mark44LowerArm.png"));
									Instance.transform.localScale = new Vector2(((Instance.transform.localScale.x <= 0)? -1.5f : 1.5f), 1.5f);

										foreach (var body in person.Limbs)
										if (body.GetComponent<GripBehaviour>())

											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.yellow;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.yellow;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 1.0f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 8000f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().ImpactStrength = 5f;
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
												Instance.transform.localScale = new Vector2(((Instance.transform.localScale.x <= 0)? -1.5f : 1.5f), 1.5f);
											};
										}
										
									}
                   }
                }
            );
            ModAPI.Register(
            new Modification()
            {
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "<color=blue>{HERO}<color=white>  WarBuster " + ModTag,
					DescriptionOverride = "This Lone Gunslinger Act Is Unnecessary, you don’t Have To Do This Alone", //new item description
					CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Art/skins/warmachine/hulkbuster/warbusterpfp.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   
									{
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("Art/skins/warmachine/hulkbuster/warbusterEyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 0f, 0f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Foreground";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("Art/skins/warmachine/hulkbuster/warbusterARC.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 0f, 0f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";			

									int X;
									var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
									person.SetBodyTextures(ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbuster.png"), ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbuster.png"), null, 2);

									AudioClip Repulsor = ModAPI.LoadSound("Shot.mp3");  
									
									upper.gameObject.AddComponent<warmachineuni>();
									
									
									person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/warmachine/hulkbuster/warbusterHead.png", 2);
									person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterHead.png"));
									person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterHead.png"));
									
									
									person.Limbs[1].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/warmachine/hulkbuster/warbusterUpper.png", 2);
									person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterUpper.png"));
									person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterUpper.png"));
									
									
									person.Limbs[2].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/warmachine/hulkbuster/warbusterMiddle.png", 2);
									person.Limbs[2].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterMiddle.png"));
									person.Limbs[2].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterMiddle.png"));
									
									
									person.Limbs[3].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/warmachine/hulkbuster/warbusterLower.png", 2);
									person.Limbs[3].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterLower.png"));
									person.Limbs[3].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterLower.png"));
									
									
									person.Limbs[4].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/warmachine/hulkbuster/warbusterUpperLeg.png", 2);
									person.Limbs[4].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterUpperLeg.png"));
									person.Limbs[4].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterUpperLeg.png"));
									
									
									person.Limbs[5].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/warmachine/hulkbuster/warbusterLowerLeg.png", 2);
									person.Limbs[5].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterLowerLeg.png"));
									person.Limbs[5].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterLowerLeg.png"));
									
									
									person.Limbs[6].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/warmachine/hulkbuster/warbusterFoot.png", 2);
									person.Limbs[6].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterFoot.png"));
									person.Limbs[6].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterFoot.png"));
									
									
									person.Limbs[7].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/warmachine/hulkbuster/warbusterUpperLeg.png", 2);
									person.Limbs[7].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterUpperLeg.png"));
									person.Limbs[7].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterUpperLeg.png"));
									
									
									person.Limbs[8].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/warmachine/hulkbuster/warbusterLowerLeg.png", 2);
									person.Limbs[8].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterLowerLeg.png"));
									person.Limbs[8].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterLowerLeg.png"));
									
									
									person.Limbs[9].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/warmachine/hulkbuster/warbusterFoot.png", 2);
									person.Limbs[9].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterFoot.png"));
									person.Limbs[9].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterFoot.png"));
									
									
									person.Limbs[10].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/warmachine/hulkbuster/warbusterUpperArm.png", 2);
									person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterUpperArm.png"));
									person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterUpperArm.png"));
									
									
									person.Limbs[11].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/warmachine/hulkbuster/warbusterLowerArm.png", 2);
									person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterLowerArm.png"));
									person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterLowerArm.png"));
									
									
									person.Limbs[12].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/warmachine/hulkbuster/warbusterUpperArm.png", 2);
									person.Limbs[12].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterUpperArm.png"));
									person.Limbs[12].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterUpperArm.png"));
									
									
									person.Limbs[13].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/warmachine/hulkbuster/warbusterLowerArm.png", 2);
									person.Limbs[13].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterLowerArm.png"));
									person.Limbs[13].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/warmachine/hulkbuster/warbusterLowerArm.png"));
									Instance.transform.localScale = new Vector2(((Instance.transform.localScale.x <= 0)? -1.5f : 1.5f), 1.5f);

										foreach (var body in person.Limbs)
										if (body.GetComponent<GripBehaviour>())

											
										
										{
											body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
											{
												GameObject HandOBJ = UnityEngine.Object.Instantiate(ModAPI.FindSpawnable("Machine Blaster").Prefab.GetComponent<BlasterBehaviour>().Bolt);
												
												ModAPI.CreateParticleEffect("FuseBlown", body.transform.position);
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.startColor = Color.red;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.endColor = Color.red;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Trail.widthMultiplier += 1.0f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().Speed = 8000f;
												HandOBJ.GetComponent<BlasterboltBehaviour>().ImpactStrength = 5f;
												
												HandOBJ.transform.position = body.gameObject.transform.position;
												HandOBJ.transform.eulerAngles = body.gameObject.transform.eulerAngles;
												HandOBJ.transform.eulerAngles += new Vector3(0, 0, 270);
												
												AudioSource audio = body.gameObject.AddComponent<AudioSource>();
												audio.spatialBlend = 1;
												audio.PlayOneShot(Repulsor);
											};
										}
										
									}
                   }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
            		NameOverride = "<color=blue>{HERO}<color=white> Hulk " + ModTag,
                    DescriptionOverride = "HULk.. SMASH!!! \n - Has Mutliple Textures", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/Hulk/pfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/Hulk/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);

                        int X;

                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Hulk/CustomSkins/Skin1.png"),"Professor Hulk", "Professor Hulk");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Hulk/CustomSkins/Skin2.png"),"Hulk Noir", "Hulk Noir");
                        PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Hulk/CustomSkins/carnage.png"),"Carnage", "Carnage");
                        
                        foreach (LimbBehaviour Limb in person.Limbs)
                        {
                                Limb.BreakingThreshold *= 10f;
                                Limb.ImmuneToDamage = true;
                                Limb.ImpactPainMultiplier = 0f;
                                Limb.ShotDamageMultiplier = 0f;
                                Limb.Vitality *= 100f;
                                Limb.Health *= 100f;
                                Limb.FakeUprightForce *= 1.65f;
                                Limb.InitialHealth *= 100f;
                                Limb.IsLethalToBreak = false;
                                Limb.PhysicalBehaviour.BurningProgressionMultiplier = 0f;
                                Limb.CirculationBehaviour.BloodLossRateMultiplier = 0f;
                                Limb.CirculationBehaviour.ImmuneToDamage = true;
            					person.SetSecondBruiseColor(21, 125, 0); //second bruise colour. red by default
            					person.SetBloodColour(21, 125, 0);
                        }
                        Instance.transform.localScale = new Vector2(((Instance.transform.localScale.x <= 0)? -1.5f : 1.5f), 1.5f);
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
           			NameOverride = "<color=red>{VILLIAN}<color=white> Red Hulk " + ModTag,
                    DescriptionOverride = "HULk.. SMASH!!!", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/redHulk/pfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/redHulk/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);

                        int X;
                        
                        foreach (LimbBehaviour Limb in person.Limbs)
                        {
                                Limb.BreakingThreshold *= 10f;
                                Limb.ImmuneToDamage = true;
                                Limb.ImpactPainMultiplier = 0f;
                                Limb.ShotDamageMultiplier = 0f;
                                Limb.Vitality *= 100f;
                                Limb.Health *= 100f;
                                Limb.FakeUprightForce *= 1.65f;
                                Limb.InitialHealth *= 100f;
                                Limb.IsLethalToBreak = false;
                                Limb.PhysicalBehaviour.BurningProgressionMultiplier = 0f;
                                Limb.CirculationBehaviour.BloodLossRateMultiplier = 0f;
                                Limb.CirculationBehaviour.ImmuneToDamage = true;
            					person.SetSecondBruiseColor(1, 0, 0); //second bruise colour. red by default
            					person.SetBloodColour(1, 0, 0);
                        }
                        Instance.transform.localScale = new Vector2(((Instance.transform.localScale.x <= 0)? -1.5f : 1.5f), 1.5f);
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
            		NameOverride = "<color=blue>{HERO}<color=white> The Thing " + ModTag,
                    DescriptionOverride = "Rocky boi", //new item description
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/thething/pfp.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {

                        //get person
                        var person = Instance.GetComponent<PersonBehaviour>();

                        person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/thething/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);

                        int X;
                        
                        foreach (LimbBehaviour Limb in person.Limbs)
                        {
                                Limb.BreakingThreshold *= 10f;
                                Limb.ImmuneToDamage = true;
                                Limb.ImpactPainMultiplier = 0f;
                                Limb.ShotDamageMultiplier = 0f;
                                Limb.Vitality *= 100f;
                                Limb.Health *= 100f;
                                Limb.FakeUprightForce *= 1.65f;
                                Limb.InitialHealth *= 100f;
                                Limb.IsLethalToBreak = false;
                                Limb.PhysicalBehaviour.BurningProgressionMultiplier = 0f;
                                Limb.CirculationBehaviour.BloodLossRateMultiplier = 0f;
                                Limb.CirculationBehaviour.ImmuneToDamage = true;
                        }
                        Instance.transform.localScale = new Vector2(((Instance.transform.localScale.x <= 0)? -1.5f : 1.5f), 1.5f);
                    }
                }
            );
            var discord = ModAPI.FindSpawnable("Discord");
            if (discord == null)
            {
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = "Discord",
                        DescriptionOverride = "Berry Studios Discord",
                        CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"),
                        ThumbnailOverride = ModAPI.LoadSprite("discord.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Utils.OpenURL("https://discord.gg/x5gMC5veHU");
                            GameObject.Destroy(Instance);
                        }
                    }
                );
            }
            var discord2 = ModAPI.FindSpawnable("Join The Discord");
            if (discord2 == null)
            {
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = "Join The Discord",
                        DescriptionOverride = "Berry Studios Discord",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("discord.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Utils.OpenURL("https://discord.gg/x5gMC5veHU");
                            GameObject.Destroy(Instance);
                        }
                    }
                );
            }
            var youtube = ModAPI.FindSpawnable("youtube");
            if (youtube == null)
            {
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = "Youtube",
                        DescriptionOverride = "Blocksify's Youtube Channel",
                        CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"),
                        ThumbnailOverride = ModAPI.LoadSprite("Youtube.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Utils.OpenURL("https://www.youtube.com/c/sanntry");
                            GameObject.Destroy(Instance);
                        }
                    }
                );
                
            var youtube2 = ModAPI.FindSpawnable("Check Out This Channel!");
            if (youtube2 == null)
            {
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = "Check Out This Channel!",
                        DescriptionOverride = "Blocksify's Youtube Channel",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("Youtube.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Utils.OpenURL("https://www.youtube.com/c/sanntry");
                            GameObject.Destroy(Instance);
                        }
                    }
                );
            }

			ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
					NameOverride = "<color=red>{VILLIAN}<color=white> Ivan Vanko " + ModTag,
					DescriptionOverride = "If you can make God bleed, the people will cease to believe in him. And there will be blood in the water, and the sharks will come. The truth, all I have to do is sit here and watch as the world will consume you.", //new item description
					CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("art/skins/ivan/pfp.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
									var person = Instance.GetComponent<PersonBehaviour>();
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
								
						
									var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
									person.SetBodyTextures(ModAPI.LoadTexture("art/skins/ivan/skin layer.png"), ModAPI.LoadTexture("art/skins/humanthings/flesh layer.png"), null, 2);


            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("art/skins/ivan/ARC.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 1f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									
									
									

								//	foreach (var body in person.Limbs)
								//	{
								//		body.transform.root.localScale *= 0.999f;
								///		body.BaseStrength *= 2f;
								//		body.Health += 100f;
								//		body.InitialHealth += 100f;
								//		body.ShotDamageMultiplier *= 0f;
								//		body.Vitality *= 4.5f;
								//		body.ImpactPainMultiplier *= 0f;
								//		body.Numbness *= 2f;
								//		body.IsLethalToBreak = false;
								//		body.BreakingThreshold += 55f;
								//		body.RegenerationSpeed += 5f;
								//		body.CirculationBehaviour.BloodFlow *= 4f;
								//		body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
								//		body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
								//		body.PhysicalBehaviour.ConductOverride = true;
								//		body.PhysicalBehaviour.ForceNoCharge = true;					
								//	}
												
									//load textures for each layer (see Human textures folder in this repository)
						//var skin = ModAPI.LoadTexture("t/Vanko/1.png");
						//var flesh = ModAPI.LoadTexture("t/2.png");
						//var bone = ModAPI.LoadTexture("t/3.png");
			
						//get person
					//	Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2);
					}
				}
			);
             ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Hammer"),
                     NameOverride = "<color=purple>{WEAPON}<color=white> Mjolnir " + ModTag,
                    DescriptionOverride = "Thor's Hammer \n - Punch someone with this to use it's special attack.",
                    CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"),
                    ThumbnailOverride = ModAPI.LoadSprite("art/skins/Thor/Hammerpfp.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("art/skins/Thor/Hammer.png");
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1f;

                        GameObject glow = new GameObject();

                        glow.transform.SetParent(Instance.transform);
                        glow.transform.localPosition = Vector2.zero;
                        glow.transform.localScale = Vector2.one;
                        glow.transform.localRotation = Quaternion.identity;

                        SpriteRenderer glowSprite = glow.AddComponent<SpriteRenderer>();
                        glowSprite.material = ModAPI.FindMaterial("VeryBright");
                        glowSprite.color = Color.cyan;

                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 1f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 1f;
                        
                        ModAPI.CreateLight(glow.transform, Color.cyan, 1f, 0.5f);
                        
                        Instance.gameObject.AddComponent<Hammer>();
                        Instance.FixColliders();
                        }
                    }
                ); 
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = "<color=red>{VILLIAN}<color=white> Electro" + ModTag,
                DescriptionOverride = "You got that suit, you help a lot of poor people. I just thought you was gonna be Black.",
                CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"),
                ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/electro/pfp.png"),
                AfterSpawn = (Instance) =>
                {
                    var person = Instance.GetComponent<PersonBehaviour>();
                   person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/electro/Suit Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);   
				   PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/electro/CustomSkins/no suit.png"), "No Suit", "No Suit"); 

					var head = Instance.transform.Find("Head");
					var upper = Instance.transform.Find("Body").Find("UpperBody");
					var middle = Instance.transform.Find("Body").Find("MiddleBody");
					var lower = Instance.transform.Find("Body").Find("LowerBody");
					var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
					var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
					var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
					var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
					var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
					var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
					var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
					var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");

                    AudioClip[] Electric = new AudioClip[]
                        {
                            ModAPI.LoadSound("Art/Skins/electro/zap.mp3"),
                        };
                    arm1.gameObject.AddComponent<FirearmBehaviour>().ShotSounds = Electric;
                    arm2.gameObject.AddComponent<FirearmBehaviour>().ShotSounds = Electric;

                        foreach (var body in person.Limbs)
                        {
                            //Sets up power on specific bodypart. supported bodyparts are (Head,LowerArm,UpperBody)
                            if (body.gameObject.name.Contains("LowerArm"))
                                Electropower.SetUpPower(body, person, Instance);
                        }       

                    }
                }
            );
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = "<color=red>{VILLIAN}<color=white> Mysterio" + ModTag,
                DescriptionOverride = "You got that suit, you help a lot of poor people. I just thought you was gonna be Black.",
                CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"),
                ThumbnailOverride = ModAPI.LoadSprite("Art/Skins/Mysterio/pfp.png"),
                AfterSpawn = (Instance) =>
                {
                    var person = Instance.GetComponent<PersonBehaviour>();
                   person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/Mysterio/Skin_Layer.png"), ModAPI.LoadTexture("Art/Skins/HumanThings/Flesh Layer.png"), null, 2);   
				   PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Mysterio/CustomSkins/no suit.png"), "No Suit", "No Suit"); 
				   PowerPackFrameworkFunctions.AddSkin(person, ModAPI.LoadTexture("Art/Skins/Mysterio/CustomSkins/unmasked.png"), "Un-Masked", "Un-Masked"); 

					var head = Instance.transform.Find("Head");
					var upper = Instance.transform.Find("Body").Find("UpperBody");
					var middle = Instance.transform.Find("Body").Find("MiddleBody");
					var lower = Instance.transform.Find("Body").Find("LowerBody");
					var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
					var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
					var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
					var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
					var arm1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
					var arm2 = Instance.transform.Find("BackArm").Find("UpperArm");
					var hand1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
					var hand2 = Instance.transform.Find("BackArm").Find("LowerArm");

                        foreach (var body in person.Limbs)
                        {
                            //Sets up power on specific bodypart. supported bodyparts are (Head,LowerArm,UpperBody)
                            if (body.gameObject.name.Contains("LowerArm"))
                                Mysteriopower.SetUpPower(body, person, Instance);
                        }       

                    }
                }
            );
				ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
					NameOverride = "<color=red>{VILLIAN}<color=white> Hammer Drone " + ModTag,
					DescriptionOverride = "Super Bunker Buster! Ex-WIFE!", //new item description
					CategoryOverride = ModAPI.FindCategory("Blocksify's Marvel Multiverse"), //new item category
					ThumbnailOverride = ModAPI.LoadSprite("Art/skins/ivan/dronepfp.png"), //new item thumbnail (relative path)
					AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
					{   		
                    var person = Instance.GetComponent<PersonBehaviour>();
                   person.SetBodyTextures(ModAPI.LoadTexture("Art/Skins/ivan/drone.png"), ModAPI.LoadTexture("Art/Skins/ivan/dronedestroyed.png"), null, 2);   
									
									var head = Instance.transform.Find("Head");
									var upper = Instance.transform.Find("Body").Find("UpperBody");
									var middle = Instance.transform.Find("Body").Find("MiddleBody");
									var lower = Instance.transform.Find("Body").Find("LowerBody");
									var leg1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
									var leg2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
									var leg3 = Instance.transform.Find("BackLeg").Find("UpperLeg");
									var leg4 = Instance.transform.Find("BackLeg").Find("LowerLeg");
									var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
									var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
									
									
						
						
						
						
						
						
						
						
						
									GameObject Eyebigtime = new GameObject();
            						Eyebigtime.transform.parent = head;
            						Eyebigtime.transform.localPosition = new Vector3(0f, 0f);
            						Eyebigtime.transform.localScale = new Vector3(0.5f, 0.5f);

            						var eyebigtimeSprite = Eyebigtime.AddComponent<SpriteRenderer>();

            						eyebigtimeSprite.sprite = ModAPI.LoadSprite("art/skins/ivan/droneEyelight.png");
									eyebigtimeSprite.material = ModAPI.FindMaterial("VeryBright");
            						eyebigtimeSprite.color = new Color(1f, 1f, 1f, 0.25f);
            						eyebigtimeSprite.sortingLayerName = "Foreground";

            						GameObject upperbigtime = new GameObject();
            						upperbigtime.transform.parent = upper;
            						upperbigtime.transform.localPosition = new Vector4(0f, 0f);
            						upperbigtime.transform.localScale = new Vector4(0.5f, 0.5f);

            						var upperbigtimeprite = upperbigtime.AddComponent<SpriteRenderer>();

            						upperbigtimeprite.sprite = ModAPI.LoadSprite("Art/Skins/ivan/droneARC.png");
            						upperbigtimeprite.material = ModAPI.FindMaterial("VeryBright");
									upperbigtimeprite.color = new Color(1f, 1f, 1f, 0.25f);
									upperbigtimeprite.sortingLayerName = "Foreground";		

									
									
									person.Limbs[0].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/Skins/ivan/DroneHead.png", 2);
									person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/Skins/ivan/DroneHead.png"));
									person.Limbs[0].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/Skins/ivan/DroneHead.png"));
									
									
									
									person.Limbs[1].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/Skins/ivan/DroneUpper.png", 2);
									person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ivan/DroneUpper.png"));
									person.Limbs[1].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ivan/DroneUpper.png"));
									
									
									
									person.Limbs[2].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ivan/DroneMiddle.png", 2);
									person.Limbs[2].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ivan/DroneMiddle.png"));
									person.Limbs[2].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ivan/DroneMiddle.png"));
									
									
									
									person.Limbs[3].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ivan/DroneLower.png", 2);
									person.Limbs[3].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ivan/DroneLower.png"));
									person.Limbs[3].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ivan/DroneLower.png"));
									
									
									
									person.Limbs[4].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ivan/DroneUpperLeg.png", 2);
									person.Limbs[4].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ivan/DroneUpperLeg.png"));
									person.Limbs[4].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ivan/DroneUpperLeg.png"));
								
									
									
									person.Limbs[5].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ivan/DroneLowerLeg.png", 2);
									person.Limbs[5].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ivan/DroneLowerLeg.png"));
									person.Limbs[5].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ivan/DroneLowerLeg.png"));
									
									
									
									person.Limbs[6].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ivan/DroneFoot.png", 2);
									person.Limbs[6].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ivan/DroneFoot.png"));
									person.Limbs[6].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ivan/DroneFoot.png"));
						
									
									
									person.Limbs[7].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ivan/DroneUpperLeg.png", 2);
									person.Limbs[7].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ivan/DroneUpperLeg.png"));
									person.Limbs[7].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ivan/DroneUpperLeg.png"));
								
									
									
									person.Limbs[8].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ivan/DroneLowerLeg.png", 2);
									person.Limbs[8].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ivan/DroneLowerLeg.png"));
									person.Limbs[8].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ivan/DroneLowerLeg.png"));
								
									
									
									person.Limbs[9].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ivan/DroneFoot.png", 2);
									person.Limbs[9].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ivan/DroneFoot.png"));
									person.Limbs[9].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ivan/DroneFoot.png"));
									
									
									
									person.Limbs[10].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ivan/DroneUpperArm.png", 2);
									person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ivan/DroneUpperArm.png"));
									person.Limbs[10].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ivan/DroneUpperArm.png"));
							
									
									
									person.Limbs[11].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ivan/DroneLowerArm.png", 2);
									person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ivan/DroneLowerArm.png"));
									person.Limbs[11].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ivan/DroneLowerArm.png"));
								
									
									
									person.Limbs[12].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ivan/DroneUpperArm.png", 2);
									person.Limbs[12].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ivan/DroneUpperArm.png"));
									person.Limbs[12].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ivan/DroneUpperArm.png"));
								
									
									
									person.Limbs[13].SkinMaterialHandler.renderer.sprite = ModAPI.LoadSprite("Art/skins/ivan/DroneLowerArm.png", 2);
									person.Limbs[13].SkinMaterialHandler.renderer.material.SetTexture("_FleshTex", ModAPI.LoadTexture("Art/skins/ivan/DroneLowerArm.png"));
									person.Limbs[13].SkinMaterialHandler.renderer.material.SetTexture("_BoneTex", ModAPI.LoadTexture("Art/skins/ivan/DroneLowerArm.png"));
									
									 
									
									
									
									

									foreach (var body in person.Limbs)
									{
										body.transform.root.localScale *= 1.0015f;
										body.BaseStrength *= 2f;
										body.Health += 100f;
										body.InitialHealth += 100f;
										body.ShotDamageMultiplier *= 0f;
										body.Vitality *= 4.5f;
										body.ImpactPainMultiplier *= 0f;
										body.Numbness *= 2f;
										body.IsLethalToBreak = false;
										body.BreakingThreshold += 55f;
										body.RegenerationSpeed += 5f;
										body.CirculationBehaviour.BloodFlow *= 4f;
										body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
										body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Flammable Metal");
										body.PhysicalBehaviour.Wetness = Mathf.Clamp(body.PhysicalBehaviour.Wetness,0f,0.2f);
										body.PhysicalBehaviour.ConductOverride = true;
										body.PhysicalBehaviour.ForceNoCharge = true;
									
										
									}
									
									arm1.gameObject.AddComponent<BarretBehaviour>();
									arm2.gameObject.AddComponent<BarretBehaviour>();
									GameObject alsoEye = new GameObject();
									alsoEye.transform.parent = arm1;
									alsoEye.transform.localPosition = new Vector3(0f, 0f);
									alsoEye.transform.localScale = new Vector3(1f, 1f);

									var eyeSprite = alsoEye.AddComponent<SpriteRenderer>();

									eyeSprite.sprite = ModAPI.LoadSprite("Art/skins/ivan/DroneLowerArm.png");
									eyeSprite.material = ModAPI.FindMaterial("Sprites-Default");
									eyeSprite.sortingLayerName = "Bubbles";

									GameObject secondarm = new GameObject();
									secondarm.transform.parent = arm2;
									secondarm.transform.localPosition = new Vector3(0f, 0f);
									secondarm.transform.localScale = new Vector3(1f, 1f);

									var armSprite = secondarm.AddComponent<SpriteRenderer>();

									armSprite.sprite = ModAPI.LoadSprite("Art/skins/ivan/DroneLowerArm.png");
									armSprite.material = ModAPI.FindMaterial("Sprites-Default");
									armSprite.sortingLayerName = "Bottom";
									
									#endregion
					}
				}
			);
        }
    }

    }
}